/*
 * Copyright (c) 2011 Veselin Georgiev
 *
 * Cutting the bullshit:
 *  all sources here are free software; you can use them for everything you
 *  want. Just don't blame me if something goes wrong; if something happens
 *  (including, but not limited to:
 *     coredumps, formatted harddrives, ping timeouts, winamp sound skips,
 *     fried GPUs, sudden mother-in-law visits, timelimits, penis enlargement
 *     pills spam, raytracing courses, Stroeja zaporkings, Gogov getting drunk,
 *     Pesho chatting up romanian girls in the subway, incorrect global
 *     illumination, strong ionizing radiation, earthquakes, frog rain,
 *     Windows 8 installations, dangerous sporks, concrete donkey, apocalypse,
 *     or even Genadzi Karatkevich getting your butt kicked...
 *  ), then you know you have been warned.
 *
 */

#include <stdio.h>
#include <set>
#include <string>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <vector>
#include <queue>
using namespace std;

#define abs(x) ((x) < 0 ? -(x) : (x))
#define FOR(i, n) for (int i = 0; i < (int) (n); i++)
#define REP(i, V) for (int i = 0; i < (int) (V).size(); i++)
const int INF = 999666111;

set<string> configs[21];

int a[32][32];

void bt(int miny, int minx, int maxy, int maxx, int numTiles, int tilesToDo)
{
	string key;
	for (int y = miny; y <= maxy; y++) {
		if (y > miny) key += ",";
		for (int x = minx; x <= maxx; x++) {
			key += ('0' + a[y][x]);
		}
	}
	if (configs[numTiles].find(key) != configs[numTiles].end()) return;
	configs[numTiles].insert(key);
	if (numTiles == tilesToDo) return;
	for (int y = miny - 1; y <= maxy + 1; y++) {
		for (int x = minx - 1; x <= maxx + 1; x++) {
			if (a[y][x]) continue;
			if (!(a[y + 1][x] || a[y - 1][x] || a[y][x - 1] || a[y][x + 1])) continue;
			a[y][x] = 1;
			bt(min(miny, y), min(minx, x), max(maxy, y), max(maxx, x), numTiles + 1, tilesToDo);
			a[y][x] = 0;
		}
	}
}

double A, sigma = 0.3, B = 0.6;

double FF(double x)
{
	return (exp(-x/(2 * sqrt(A) * sigma * sigma)) / (sqrt(2.0 * M_PI) * sigma)) * B;
}

double randomFloat()
{
	return rand() / (double) RAND_MAX;
}

void generator(int N, int S, int c1, int c2)
{
	A = N * N;
	memset(a, 0, sizeof(a));
	int centers[6][2];
	for (int i = 0; i < S; i++) {
		centers[i][0] = rand() % N;
		centers[i][1] = rand() % N;
	}
	int m = 0;
	printf("%d\n", N);
	for (int y = 0; y < N; y++) {
		for (int x = 0; x < N; x++) {
			int d = INF;
			for (int i = 0; i < S; i++) {
				d = min(d, abs(x - centers[i][1]) + abs(y - centers[i][0]));
			}
			if (randomFloat() < FF(d))
				a[y][x] = rand() % (c2 - c1 + 1) + c1;
			if (a[y][x]) {m ++; printf(" %2d ", a[y][x]); }
			else printf("  # ");
		}
		printf("\n");
	}

}

void testGenerator()
{
	srand(time(NULL));
	generator(5, 1, 0, 5);
	printf("//\n//\n");
	generator(15, 3, 5, 10);
	printf("//\n//\n");
	generator(30, 5, 10, 20);
	printf("//\n//\n");
}

struct ReachInfo {
	int index;
	int x, y;
};

struct Center {
	int x, y;
	int value;
	vector<ReachInfo> reachable;
};

vector<Center> p;
int fillState[32][32], f[32][32];
const int dir[4][2] = { { -1, 0 }, { 1, 0 }, { 0, -1 }, { 0, 1 } };
int N;
vector<pair<int, int> > bestSolution;
int bestScore;
bool exposedNumbers;

void input(void)
{
	exposedNumbers = false;
	FILE* f = fopen("game.in", "rt");
	fscanf(f, "%d", &N);
	memset(fillState, 0, sizeof(fillState));
	FOR(y, N) FOR(x, N) {
		char t[20];
		fscanf(f, "%s", t);
		if (t[0] == '#') fillState[y + 1][x + 1] = 0;
		else if (t[0] == 'B') fillState[y + 1][x + 1] = 1;
		else {
			exposedNumbers = true;
			int val;
			sscanf(t, "%d", &val);
			fillState[y + 1][x + 1] = 2 + val;
		}
	}
	for (int y = 1; y <= N; y++) for (int x = 1; x <= N; x++) if (fillState[y][x] != 1) {
		FOR(d, 4) {
			int nx = x + dir[d][0];
			int ny = y + dir[d][1];
			if (fillState[ny][nx] == 1) fillState[y][x] = -1;
		}
	}
	for (int y = 1; y <= N; y++) {
		for (int x = 1; x <= N; x++) {
			if (fillState[y][x] == -1) fillState[y][x] = 1;
			//printf("%d", fillState[y][x]);
		}
		//printf("\n");
	}

	// guard around:
	FOR(i, N+2) {
		fillState[0][i] = fillState[i][0] = fillState[N + 1][i] = fillState[i][N + 1] = 1;
	}
	// find centers
	for (int y = 1; y <= N; y++) for (int x = 1; x <= N; x++) {
		if (fillState[y][x] > 2) {
			Center c;
			c.x = x;
			c.y = y;
			c.value = fillState[y][x] - 2;
			p.push_back(c);
		}
	}
	fclose(f);
}

struct QI {
	int x, y, depth;
	QI() {}
	QI(int x, int y, int depth)
	{
		this->x = x; this->y = y; this->depth = depth;
	}
};

bool bfs1(int x, int y, int toFill)
{
	memcpy(f, fillState, sizeof(f));
	queue<QI> q;
	q.push(QI(x, y, 0));
	toFill--;
	while (toFill > 0 && !q.empty()) {
		QI qi = q.front();
		q.pop();
		FOR(d, 4) {
			int nx = qi.x + dir[d][0];
			int ny = qi.y + dir[d][1];
			if (!f[ny][nx]) {
				f[ny][nx] = -1;
				q.push(QI(nx, ny, qi.depth + 1));
				if (--toFill == 0) return true;
			}
		}
	}
	return toFill <= 0;
}

void reduce(void)
{
	vector<Center> new_p;
	REP(i, p) {
		const Center& c = p[i];
		if (bfs1(c.x, c.y, c.value))
			new_p.push_back(c);
	}
	p = new_p;
}

void strategy_minSize(void)
{
	bestScore = 100;
	REP(i, p) {
		if (p[i].value >= bestScore) continue;
		bestScore = p[i].value;
		bestSolution.clear();
		bestSolution.push_back(make_pair(p[i].x, p[i].y));
		bfs1(p[i].x, p[i].y, p[i].value);
		for (int y = 1; y <= N; y++) for (int x = 1; x <= N; x++) if (f[y][x] == -1) {
			bestSolution.push_back(make_pair(x, y));
		}
	}
}

struct FillInfo {
	int dist;
	int prevX, prevY;
};

FillInfo info[4][32][32];

void bfs2(int sx, int sy, int maxDepth, int offset)
{
	for (int y = 0; y <= N + 1; y++) for (int x = 0; x <= N + 1; x++)
		info[offset][y][x].dist = INF;
	info[offset][sy][sx].dist = 0;
	queue<QI> q;
	q.push(QI(sx, sy, 0));
	while (!q.empty()) {
		QI qi = q.front();
		q.pop();
		if (qi.depth == maxDepth - 1) continue;
		FOR(d, 4) {
			int x = qi.x + dir[(d + offset) % 4][0];
			int y = qi.y + dir[(d + offset) % 4][1];
			if (fillState[y][x] == 0 && info[offset][y][x].dist > qi.depth + 1) {
				info[offset][y][x].dist = qi.depth + 1;
				info[offset][y][x].prevX = qi.x;
				info[offset][y][x].prevY = qi.y;
				q.push(QI(x, y, qi.depth + 1));
			}
		}
	}
}

struct PathInfo {
	int index;
	int cost;
};

int NUMITERS;

int realCost(const ReachInfo& r, int offset, int pts[][2] = NULL, int* cnt = NULL)
{
	int x = r.x;
	int y = r.y;
	int cost = 0;
	while (!f[y][x]) {
		cost++;
		int nx = info[offset][y][x].prevX;
		int ny = info[offset][y][x].prevY;
		if (cnt) {
			pts[(*cnt)][0] = x;
			pts[(*cnt)][1] = y;
			(*cnt)++;
			f[y][x] = 1;
		}
		x = nx, y = ny;
	}
	return cost;
}

void findBestFill(const Center& c)
{
	int pts[32][2], m;
	pts[0][0] = c.x;
	pts[0][1] = c.y;
	for (int iters = 0; iters < NUMITERS; iters++) {
		int offset = iters % 4;
		m = 1;
		f[c.y][c.x] = 1;
		PathInfo pi[1000];
		int k = 0;
		REP(i, c.reachable) {
			pi[k].index = i;
			pi[k].cost = realCost(c.reachable[i], offset);
			k++;
		}
		int numFree = c.value - 1;
		int meddled = 1; // myself
		while (k > 0) {
			int nk = 0;
			FOR(i, k) {
				if (pi[i].cost == 0) {
					meddled++;
				} else if (pi[i].cost <= numFree) {
					pi[nk++] = pi[i];
				}
			}
			k = nk;
			if (k == 0) break;
			int chosen = rand() % k;
			numFree -= realCost(c.reachable[pi[chosen].index], offset, pts, &m);
			pi[chosen].cost = 0;
			FOR(i, k)
				if (i != chosen)
					pi[i].cost = realCost(c.reachable[pi[i].index], offset);
		}
		if (meddled > bestScore && (bestScore < 0 || meddled != p.size() - 1)) {
// 			printf("New best fill with score %d\n", meddled);
			bestScore = meddled;
			bestSolution.clear();
			FOR(i, m) bestSolution.push_back(make_pair(pts[i][0], pts[i][1]));
			while (bestSolution.size() < c.value) {
				int bx = -1, by = -1;
				bool good = false;
				for (int y = 1; y <= N && !good; y++) for (int x = 1; x <= N && !good; x++) {
					if (f[y][x] || fillState[y][x] != 0) continue;
					FOR(d, 4) {
						int nx = x + dir[d][0];
						int ny = y + dir[d][1];
						if (f[ny][nx]) {
							good = true;
							bx = x;
							by = y;
							break;
						}
					}
				}
				pts[m][0] = bx;
				pts[m][1] = by;
				f[by][bx] = 1;
				m++;
				bestSolution.push_back(make_pair(bx, by));
			}
		}
		FOR(i, m) f[pts[i][1]][pts[i][0]] = 0;
	}
	f[c.y][c.x] = 0;
}

void strategy_maxMeddling(void)
{
	NUMITERS = 60000 / p.size();
	if (NUMITERS > 10000) NUMITERS = 10000;
	
	bestScore = -5;
	//
	memset(f, 0, sizeof(f));
	REP(ii, p) {
		Center& c = p[ii];
		FOR(i, 4) bfs2(c.x, c.y, c.value, i);
		REP(ij, p) if (ij != ii) {
			int minDist = INF;
			int bx, by;
			FOR(d, 4) {
				int tx = p[ij].x + dir[d][0];
				int ty = p[ij].y + dir[d][1];
				if (info[0][ty][tx].dist < minDist) {
					minDist = info[0][ty][tx].dist;
					bx = tx;
					by = ty;
				}
			}
			if (minDist < INF) {
				ReachInfo ri;
				ri.x = bx;
				ri.y = by;
				ri.index = ij;
				c.reachable.push_back(ri);
			}
		}
		if ((int) c.reachable.size() + 1 <= bestScore) continue;
#ifdef DEBUG
		printf("ii = %d (%d, %d), reachable = [", ii, c.x, c.y);
		REP(ij, c.reachable) printf("(%d, %d, idx=%d) ", c.reachable[ij].x, c.reachable[ij].y, c.reachable[ij].index);
		printf("\n");
#endif
		findBestFill(c);
	}
}

void output(void)
{
	FILE* f = fopen("game.out", "wt");
	fprintf(f, "%d\n", (int) bestSolution.size());
	REP(i, bestSolution) {
		fprintf(f, "%d %d\n", bestSolution[i].second - 1, bestSolution[i].first - 1);
	}
	fclose(f);
}

int main(int argc, char** argv)
{
	//
	int strategy = 1;
	if (argc >= 2 && !strcmp(argv[1], "gen")) {
		const int sizeSets[4][4] = {{}, {5, 1, 0, 5}, {15, 3, 5, 10}, {30, 5, 10, 20}};
		int setSize = 3;
		srand(time(NULL)); // !< Judges: this is only used for test-generation purposes; never in the actual task!
		if (argc >= 3) sscanf(argv[2], "%d", &setSize);
		generator(sizeSets[setSize][0], sizeSets[setSize][1], sizeSets[setSize][2], sizeSets[setSize][3]);
		return 0;
	}
	if (argc == 2) sscanf(argv[1], "%d", &strategy);
	input();
	reduce();
	if (p.empty()) {
		FILE* f = fopen("game.out", "wt");
		fprintf(f, "-1\n");
		if (exposedNumbers) {
			fprintf(f, "-1\n"); //I lose
		} else {
			fprintf(f, "0\n"); //Draw
		}
		fclose(f);
		return 0;
	}
#ifdef DEBUG
	REP(i, p) {
		printf("%d, %d, %d\n", p[i].x, p[i].y, p[i].value);
	}
#endif
	if (strategy == 1) {
		strategy_maxMeddling();
	} else {
		strategy_minSize();
	}
	output();
	//
	return 0;
}
